#pragma warning(disable:4786)

#include "agent_commands.h"
#include "sio_agent_proxy.h"

#include <algorithm>
#include <functional>

AgentCommand::~AgentCommand() {}

AddDataWMECommand::~AddDataWMECommand() {}

void 
AddDataWMECommand::Execute(SIOAgentProxy* agent) {
     agent->AddWME(parentId,attr.c_str(),value.c_str(),simTimeTag);
}

AddPlainWMECommand::~AddPlainWMECommand() {}

void
AddPlainWMECommand::Execute(SIOAgentProxy* agent) {
     agent->AddWME(parent.c_str(),attr.c_str(),value.c_str());
}


AddIdWMECommand::~AddIdWMECommand() {}

void
AddIdWMECommand::Execute(SIOAgentProxy* agent) {
     agent->AddWME(parentId,attr.c_str(),childId,simTimeTag);
}

RemoveWMECommand::~RemoveWMECommand() {}

void
RemoveWMECommand::Execute(SIOAgentProxy* agent) {
     agent->RemoveWME(simTimeTag);
}

CommitCommand::~CommitCommand() {}

void
CommitCommand::Execute(SIOAgentProxy* agent) {
     agent->Commit();
}

DoWMEChangesCommand::~DoWMEChangesCommand() {}

void
DoWMEChangesCommand::Execute(SIOAgentProxy* agent) {
     agent->SetTclInterp(interp);
     agent->DoWMChanges();
     agent->ClearTclInterp();
}


ReportCommands::~ReportCommands() {}

struct AddCommandArg
: std::binary_function<SIOAgentProxy*,Command,bool> {
    bool operator()(SIOAgentProxy* agent,const Command& cmd) const {
        agent->AddCommand(cmd);
        return true;
    }
};

void
ReportCommands::Execute(SIOAgentProxy* agent) {
    std::for_each(cmds.begin(),cmds.end(),std::bind1st(AddCommandArg(),agent));
	agent->EndCommands();
}




