#ifndef INCLUDED_COMMAND_H
#define INCLUDED_COMMAND_H

#include <list>
#include <string>
#include <iosfwd>
#include <utility>

/*
    This represents a command on the soarside side of things

    @author Brad Jones
 */

class Command {
public:
     typedef std::list<std::pair<std::string,std::string> > ParamList;

     Command(const std::string& inCommandName,const std::string& inSoarId) 
        : commandName(inCommandName), soarId(inSoarId) {}

     void AddParameter(const std::string& name,const std::string& value);

     const std::string& GetCommandName() const { return commandName; }
     const std::string& GetSoarId() const      { return soarId; }

     const ParamList& GetParameterList() const       { return paramList; }

	 void Describe(std::ostream& os) const;

private:
     std::string commandName;
     std::string soarId;

     ParamList paramList;
};


#endif // INCLUDED_COMMAND_H
