#include "sender.h"
#include "sgio_messages.h"
#include "sgio_socket.h"
#include "null.h"

#include <process.h>
#include <windows.h>

Sender::Sender(sgio::Socket* inSocket) 
: d_sock(inSocket) {
     Thread::BeginThread(thread_func,this);
}



Sender::~Sender() {
	d_msgQueue.Enqueue(null);

     d_quitSignal.Wait();
}



void Sender::thread_func(void* self) {
	Sender* sender = static_cast<Sender*>(self);
	sender->ThreadFunc();
}
 

void Sender::ThreadFunc() {
   try {
        for(;;) {
		   std::auto_ptr<sgio::Message> message = std::auto_ptr<sgio::Message>(GetNetMessage());
		   if(message.get() != null) {
		        message->Send(d_sock);
           }
		   else
			   break;
        }
   }
   catch(sgio::SocketException&) {}
   d_quitSignal.Set();
}






