'\"
'\" Soar man page 
'\"
.so man.macros
.HS attribute-preferences-mode soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
attribute-preferences-mode \- Set or list the attribute preferences mode
.SH SYNOPSIS
\fBattribute-preferences-mode \fR[\fImode\fR]
.BE

.SH DESCRIPTION
.PP
\fBThis command is obsolete for Soar 8.\fR  In Soar 8, the code automatically
operates as if attribute-preferences-mode = 2.
.PP
For Soar 7, this command sets and prints the attributes preferences mode.
If \fImode\fR is not given, this command prints the current 
attribute preferences mode.  If \fImode\fR is given, it must 
be one of the positive integers \fB0\fR, \fB1\fR, or \fB2\fR
and is used to reset the attribute preferences modes.
.PP
The "attribute-preferences-mode" parameter is used to control the
handling of preferences (other than acceptable and reject 
preferences) for non-context slots.  The \fImode\fR settings have
the following interpretations:
.TP
\fB0\fR
Handle them the normal (Soar 6) way.
.TP
\fB1\fR
Handle them the normal (Soar 6) way, but print a warning message 
whenever a preference other than + or - is created for a non-context
slot.
.TP
\fB2\fR
Whenever a preferences other than + or - is created for a 
non-context slot, print an error message and ignore
(discard) that preference.  For non-context slots, the set
of values installed in working memory is always equal to
the set of acceptable values minus the set of rejected
values.
.PP
The default initial setting of the "attribute-preferences-mode" 
parameter is 0.

.SH EXAMPLES
.PP
The command issued with no arguments, returns the current mode:
.DS
\fBattribute-preferences-mode\fR 
.DE 
.PP
The next example makes use of Tcl command abbreviation while setting
the mode to 1:
.DS
\fBattr  1\fR 
.DE

.SH VARIABLE

Note that the commandname uses dashes to separate the words.  There
is also a Soar variable "attribute_preferences_mode" (with underscores)
that can be used to set the mode through the the Tcl \fIset\fR command. 
If the  \fImode\fR is not given, the Tcl \fIset\fR command prints the current 
attribute preferences mode.  If \fImode\fR is given, it must 
be one of the positive integers \fB0\fR, \fB1\fR, or \fB2\fR
and is used to reset the attribute preferences modes.
.TP
\fBset attribute_preferences_mode\fR       returns the current mode
.TP
\fBset attribute_preferences_mode 1\fR     sets the mode to 1
.PP
Soar variables cannot be abbreviated in the same manner as commandnames.

.SH SEE ALSO
.PP 
\fBvariables\fI

