/*************************************************************************
 *
 *  file:  scheduler.c
 *
 * =======================================================================
 *  This code is now obsolete, replaced by code in the Tcl interface.
 *
 *  The schedule_agents function is the entry point to the multi-agent
 *  soar scheduler.  A round robin scheduling protocol is used for now.
 *
 *  In a cycle all agents are run for their specified "agent-go" duration
 *  and the X-window event queue is processed (if applicable).  The allowed
 *  values for input are some nuber of cycles.  With an input of -1, the
 *  scheduler continues until all agents are stopped.  This may happen
 *  in normal agent processing termination or through a user interrupt.
 * =======================================================================
 *
 * Copyright (c) 1995-1999 Carnegie Mellon University,
 *                         The Regents of the University of Michigan,
 *                         University of Southern California/Information
 *                         Sciences Institute.  All rights reserved.
 *
 * The Soar consortium proclaims this software is in the public domain, and
 * is made available AS IS.  Carnegie Mellon University, The University of 
 * Michigan, and The University of Southern California/Information Sciences 
 * Institute make no warranties about the software or its performance,
 * implied or otherwise.
 * =======================================================================
 */

#include "soarkernel.h"

long scheduler_cycle_count = 0;

void
schedule_agents (int cycles) 
{
  bool agent_to_run = TRUE;
  cons  * c; 
  agent * the_agent; 
  agent * prev_agent;
  int cycle_count = 0;

  prev_agent = soar_agent;

  for(c = all_soar_agents; c != NIL; c = c->rest) {
    the_agent = (agent *) c->first;
    the_agent->stop_soar = FALSE;
  }

  while (agent_to_run) {

    if (cycle_count == cycles) break;
    cycle_count++;

    agent_to_run = FALSE;

    for(c = all_soar_agents; c != NIL; c = c->rest) {
      soar_agent = (agent *) c->first;

     if (!current_agent(stop_soar)) {
       agent_to_run = TRUE;

#ifndef USE_X_DISPLAY 
        print("\nSelecting agent %s", soar_agent->name);
#endif

       soar_invoke_callbacks(soar_agent, 
			     BEFORE_SCHEDULE_CYCLE_CALLBACK,
			     (soar_call_data) TRUE);

       old_execute_go_selection();

       soar_invoke_callbacks(soar_agent, 
			     AFTER_SCHEDULE_CYCLE_CALLBACK,
			     (soar_call_data) TRUE);

#ifdef USE_X_DISPLAY
        if (soar_agent->monitor) 
          {
	    refresh_monitor_window(soar_agent);
	  }
#endif
     }
    
    }

#ifdef USE_X_DISPLAY
      handle_soar_x_events();
#endif

  }

  soar_agent = prev_agent;

}
