#pragma warning(disable:4786)
#include "tcl_commands.h"
#include "sgio_socket.h"
#include "sgio_messages.h"
#include "null.h"
#include "receiver.h"
#include "sio_soar_proxy.h"
#include "tsi.h"
#include <tcl.h>
#include <sstream>
#include <cstring>
#include <iostream>
#include <strstream>
#include <functional>

using namespace std;
using namespace sgio;

extern TSI g_tsi;
extern SIOSoarProxy* g_soarProxy;
int ManageInputLinkCmd(ClientData clientData,Tcl_Interp* interp,int argc,char* argv[]);

TclCommand::~TclCommand() {}

bool 
TclCommand::Obliterates(TclCommand* tclCommand) {
	return false;
}

bool
TclCommand::IsObliteratedBy(RunTilOutputTclCmd* rtotc) {
	return false;
}

bool
TclCommand::IsObliteratedBy(StepTclCmd* stc) {
	return false;
}

bool
TclCommand::IsObliteratedBy(StepAgentTclCmd* satc) {
	return false;
}

bool
TclCommand::IsObliteratedBy(RunAgentTilOutputTclCmd* ratotc) {
	return false;
}
  
AddAgentTclCmd::~AddAgentTclCmd() {}

void 
AddAgentTclCmd::Execute(Tcl_Interp* interp) {
    g_tsi.AddAgent(interp,agentName.c_str());
}

RemoveAgentTclCmd::~RemoveAgentTclCmd() {}

void 
RemoveAgentTclCmd::Execute(Tcl_Interp* interp) {
	g_soarProxy->DestroyAgent(agentName.c_str());
    g_tsi.RemoveAgent(interp,agentName.c_str());
}

LoadProductionsTclCmd::~LoadProductionsTclCmd() {}

void 
LoadProductionsTclCmd::Execute(Tcl_Interp* interp) {
    g_tsi.LoadProductions(interp,agentName.c_str(),path.c_str());
}

LoadReteNetTclCmd::~LoadReteNetTclCmd() {}

void 
LoadReteNetTclCmd::Execute(Tcl_Interp* interp) {
     g_tsi.LoadRetenet(interp,agentName.c_str(),path.c_str());
}


RunTilOutputTclCmd::~RunTilOutputTclCmd() {}

bool
RunTilOutputTclCmd::Obliterates(TclCommand* tclCommand) {
	if(tclCommand->IsObliteratedBy(this))
		return true;
	return false;
}

bool
RunTilOutputTclCmd::IsObliteratedBy(RunTilOutputTclCmd*) {
	return true;
}

void 
RunTilOutputTclCmd::Execute(Tcl_Interp* interp) {
    g_tsi.RunTilOutput(interp,agentName.c_str(),maxDecisions);
    g_soarProxy->PostNetMessage(std::auto_ptr<sgio::Message>(new sgio::RunDoneMessage()));
}

StepTclCmd::~StepTclCmd() {}

bool
StepTclCmd::Obliterates(TclCommand* tclCommand) {
	if(tclCommand->IsObliteratedBy(this))
		return true;
	return false;
}

bool
StepTclCmd::IsObliteratedBy(StepTclCmd*) {
	return true;
}

void 
StepTclCmd::Execute(Tcl_Interp* interp) {
    g_tsi.Step(interp,agentName.c_str());
    g_soarProxy->PostNetMessage(std::auto_ptr<sgio::Message>(new sgio::RunDoneMessage()));
}

SaveReteNetTclCmd::~SaveReteNetTclCmd() {}

void 
SaveReteNetTclCmd::Execute(Tcl_Interp* interp) {
     g_tsi.SaveRetenet(interp,agentName.c_str(),path.c_str());
}

SetWatchLevelTclCmd::~SetWatchLevelTclCmd() {}

void
SetWatchLevelTclCmd::Execute(Tcl_Interp* interp) {
	g_tsi.SetWatchLevel(interp,agentName.c_str(),watchLevel);
}

RunAgentTilOutputTclCmd::~RunAgentTilOutputTclCmd() {}

bool
RunAgentTilOutputTclCmd::Obliterates(TclCommand* tclCommand) {
	if(tclCommand->IsObliteratedBy(this))
		return true;
	return false;
}

bool
RunAgentTilOutputTclCmd::IsObliteratedBy(RunAgentTilOutputTclCmd* ratotc) {
	if(d_agentName == ratotc->d_agentName)
		return true;
	return false;
}

void
RunAgentTilOutputTclCmd::Execute(Tcl_Interp* interp) {
    g_tsi.RunAgentTilOutput(interp,d_agentName);
}

StepAgentTclCmd::~StepAgentTclCmd() {}

bool
StepAgentTclCmd::Obliterates(TclCommand* tclCommand) {
	if(tclCommand->IsObliteratedBy(this))
		return true;
	return false;
}

bool
StepAgentTclCmd::IsObliteratedBy(StepAgentTclCmd* satc) {
	if(d_agentName == satc->d_agentName)
		return true;
	return false;
}

void
StepAgentTclCmd::Execute(Tcl_Interp* interp) {
    g_tsi.StepAgent(interp,d_agentName);
}
