#pragma warning(disable:4786)

#include "tuple_converter.h"
#include "command.h"
#include <functional>
#include <algorithm>

using namespace std;

/*
    This function object compares a commands soarId string
    to another string, if they are equal then it returns true,
    false otherwise
*/
struct CommandSoarIdCmp
: binary_function<Command,string,bool> {
    bool operator()(const Command& cmd,const string& soarId) const {
        return cmd.GetSoarId() == soarId;
    }
};

void 
TupleConverter::AddTuple(const string& soarId,const string& attribute,const string& value) {
    // if this tuple is off the output-link then make a new command
    if(soarId == "I3") {
        commands.push_back(Command(attribute,value)); 
    }
    else {
        // try to find an already made command
        typedef std::list<Command>::iterator iter;
        iter i = find_if(commands.begin(),commands.end(),
                         bind2nd(CommandSoarIdCmp(),soarId));
            
        if(i != commands.end()) {
        // found it, add this tuple as a parameter
            i->AddParameter(attribute,value);
        }
    }
}
