#ifndef INCLUDED_TUPLE_CONVERTER_H
#define INCLUDED_TUPLE_CONVERTER_H

#ifndef INCLUDED_COMMAND_H
#include "command.h"
#endif // INCLUDED_COMMAND_H

#pragma warning(disable:4786)

#include <map>
#include <list>
#include <string>

class Sender;
class Command;
class SIOProxyAgent;

/*
    Tuple Converter takes a list of tuples that is
    (soarId,attribute,value) and convertes them into commands

    @author Brad Jones
*/

class TupleConverter {
public:
    /*
        This converts a tuple into a corresponding part of 
        a command
    */
    void AddTuple(const std::string& soarId,const std::string& attribute,const std::string& value);
   
    /*
        This returns a list of currently created commands
        that were made with the AddTuple calls
    */
    const std::list<Command>& GetCommands() const { return commands; }
private:
    std::list<Command> commands;
};


#endif // INCLUDED_TUPLE_CONVERTER_H
